module RussianRoulette
  class BulletEnabler
    class << self
      def enable!(app)
        app.config.after_initialize do
          require "bullet"
          Bullet.enable = true
          Bullet.alert = true
          Bullet.bullet_logger = true
        end if fire?(app)
      end

      def fire?(app)
        reason = if app.config.respond_to?(:reason_to_fire)
          app.config.reason_to_fire
        else
          default_reason
        end
        reason.()
      end

      def default_reason
        -> { Time.now.tuesday? && Time.now.to_date.cweek.modulo(2).zero? }
      end
    end
  end
end
